commit 1362535353af70ccb0abaf7e6595443c3e12590c
Author: Jan Pašek <janpasek97@gmail.com>
Date:   Mon Mar 29 14:57:29 2021 +0200

    Re #8474 - Separated issuer and subject in create_certificate.html

diff --git a/static/create_certificate.html b/static/create_certificate.html
index ce6a10a..e2e6467 100644
--- a/static/create_certificate.html
+++ b/static/create_certificate.html
@@ -6,137 +6,144 @@
     <link rel="stylesheet" href="/static/css/bootstrap.min.css">
 </head>
 <body class="p-4">
-    <h1>Create Certificate</h1>
+    <div id="create-certificate-content" class="container">
+        <h1 class="text-center">Create Certificate</h1>
+        <table class="ml-auto mr-auto">
+            <tr>
+                <div class="form-group">
+                    <td><label for="CA">Certificate Authority:</label></td>
+                    <td class="pl-3">
+                        <select name="CA" id="CA" class="form-control">
+                            <option value="volvo">Self-Signed</option>
+                            <option value="#test-cert-id">Test</option>
+                        </select>
+                    </td>
+                </div>
+            </tr>
+            <tr>
+                <div class="form-group">
+                    <td><label for="validity_start">Validity start:</label></td>
+                    <td class="pl-3"><input type="date" id="validity_start" name="validity_start" class="form-control"></td>
+                </div>
+            </tr>
+            <tr>
+                <div class="form-group">
+                    <td><label for="validity_end">Validity end:</label></td>
+                    <td class="pl-3"><input type="date" id="validity_end" name="validity_end" class="form-control"></td>
+                </div>
+            </tr>
+            <tr>
+                <td colspan="2"><h5>Issuer</h5></td>
+            </tr>
+            <tr>
+                <div class="form-group">
+                    <td><label for="issuer_CN">Common Name:</label></td>
+                    <td class="pl-3"><input type="text" id="issuer_CN" name="issuer_CN" class="form-control" disabled></td>
+                </div>
+            </tr>
+            <tr>
+                <div class="form-group">
+                    <td><label for="issuer_C">Country Code:</label></td>
+                    <td class="pl-3"><input type="text" id="issuer_C" name="issuer_C" class="form-control" disabled></td>
+                </div>
+            </tr>
+            <tr>
+                <div class="form-group">
+                    <td><label for="issuer_L">Locality:</label></td>
+                    <td class="pl-3"><input type="text" id="issuer_L" name="issuer_L" class="form-control" disabled></td>
+                </div>
+            </tr>
+            <tr>
+                <div class="form-group">
+                    <td><label for="issuer_ST">Province/State:</label></td>
+                    <td class="pl-3"><input type="text" id="issuer_ST" name="issuer_ST" class="form-control" disabled></td>
+                </div>
+            </tr>
+            <tr>
+                <div class="form-group">
+                    <td><label for="issuer_O">Organization:</label></td>
+                    <td class="pl-3"><input type="text" id="issuer_O" name="issuer_O" class="form-control" disabled></td>
+                </div>
+            </tr>
+            <tr>
+                <div class="form-group">
+                    <td><label for="issuer_OU">Organization Unit:</label></td>
+                    <td class="pl-3"><input type="text" id="issuer_OU" name="issuer_OU" class="form-control" disabled></td>
+                </div>
+            </tr>
+            <tr>
+                <div class="form-group">
+                    <td><label for="issuer_emailAddress">Email:</label></td>
+                    <td class="pl-3"><input type="email" id="issuer_emailAddress" name="issuer_emailAddress" class="form-control" disabled></td>
+                </div>
+            </tr>
+            <tr>
+                <td colspan="2"><h5>Subject</h5></td>
+            </tr>
+            <tr>
+                <div class="form-group">
+                    <td><label for="subject_CN">Common Name:</label></td>
+                    <td class="pl-3"><input type="text" id="subject_CN" name="subject_CN" class="form-control"></td>
+                </div>
+            </tr>
+            <tr>
+                <div class="form-group">
+                    <td><label for="subject_C">Country Code:</label></td>
+                    <td class="pl-3"><input type="text" id="subject_C" name="subject_C" class="form-control"></td>
+                </div>
+            </tr>
+            <tr>
+                <div class="form-group">
+                    <td><label for="subject_L">Locality:</label></td>
+                    <td class="pl-3"><input type="text" id="subject_L" name="subject_L" class="form-control"></td>
+                </div>
+            </tr>
+            <tr>
+                <div class="form-group">
+                    <td><label for="subject_ST">Province/State:</label></td>
+                    <td class="pl-3"><input type="text" id="subject_ST" name="subject_ST" class="form-control"></td>
+                </div>
+            </tr>
+            <tr>
+                <div class="form-group">
+                    <td><label for="subject_O">Organization:</label></td>
+                    <td class="pl-3"><input type="text" id="subject_O" name="subject_O" class="form-control"></td>
+                </div>
+            </tr>
+            <tr>
+                <div class="form-group">
+                    <td><label for="subject_OU">Organization Unit:</label></td>
+                    <td class="pl-3"><input type="text" id="subject_OU" name="subject_OU" class="form-control"></td>
+                </div>
+            </tr>
+            <tr>
+                <div class="form-group">
+                    <td><label for="subject_emailAddress">Email:</label></td>
+                    <td class="pl-3"><input type="email" id="subject_emailAddress" name="subject_emailAddress" class="form-control"></td>
+                </div>
+            </tr>
+            <tr>
+                <td>Usage:</td>
+                <td class="form-check">
+                    <input class="form-check-input" type="checkbox" id="isCA" name="isCA" value="CA">
+                    <label class="form-check-label" for="isCA">CA</label><br>
 
-    <table>
-        <tr>
-            <div class="form-group">
-                <td><label for="CA">Choose a car:</label></td>
-                <td>
-                    <select name="CA" id="CA" class="form-control">
-                        <option value="volvo">Self-Signed</option>
-                        <option value="#test-cert-id">Test</option>
-                    </select>
-                </td>
-            </div>
-        </tr>
-        <tr>
-            <div class="form-group">
-                <td><label for="validity_start">Validity start:</label></td>
-                <td><input type="date" id="validity_start" name="validity_start" class="form-control"></td>
-            </div>
-        </tr>
-        <tr>
-            <div class="form-group">
-                <td><label for="validity_end">Validity end:</label></td>
-                <td><input type="date" id="validity_end" name="validity_end" class="form-control"></td>
-            </div>
-        </tr>
-        <tr>
-            <div class="form-group">
-                <td><label for="issuer_CN">Common Name:</label></td>
-                <td><input type="text" id="issuer_CN" name="issuer_CN" class="form-control" disabled></td>
-            </div>
-        </tr>
-        <tr>
-            <div class="form-group">
-                <td><label for="issuer_C">Country Code:</label></td>
-                <td><input type="text" id="issuer_C" name="issuer_C" class="form-control" disabled></td>
-            </div>
-        </tr>
-        <tr>
-            <div class="form-group">
-                <td><label for="issuer_L">Locality:</label></td>
-                <td><input type="text" id="issuer_L" name="issuer_L" class="form-control" disabled></td>
-            </div>
-        </tr>
-        <tr>
-            <div class="form-group">
-                <td><label for="issuer_ST">Province/State:</label></td>
-                <td><input type="text" id="issuer_ST" name="issuer_ST" class="form-control" disabled></td>
-            </div>
-        </tr>
-        <tr>
-            <div class="form-group">
-                <td><label for="issuer_O">Organization:</label></td>
-                <td><input type="text" id="issuer_O" name="issuer_O" class="form-control" disabled></td>
-            </div>
-        </tr>
-        <tr>
-            <div class="form-group">
-                <td><label for="issuer_OU">Organization Unit:</label></td>
-                <td><input type="text" id="issuer_OU" name="issuer_OU" class="form-control" disabled></td>
-            </div>
-        </tr>
-        <tr>
-            <div class="form-group">
-                <td><label for="issuer_emailAddress">Email:</label></td>
-                <td><input type="email" id="issuer_emailAddress" name="issuer_emailAddress" class="form-control" disabled></td>
-            </div>
-        </tr>
-        <tr>
-            <div class="form-group">
-                <td><label for="subject_CN">Common Name:</label></td>
-                <td><input type="text" id="subject_CN" name="subject_CN" class="form-control"></td>
-            </div>
-        </tr>
-        <tr>
-            <div class="form-group">
-                <td><label for="subject_C">Country Code:</label></td>
-                <td><input type="text" id="subject_C" name="subject_C" class="form-control"></td>
-            </div>
-        </tr>
-        <tr>
-            <div class="form-group">
-                <td><label for="subject_L">Locality:</label></td>
-                <td><input type="text" id="subject_L" name="subject_L" class="form-control"></td>
-            </div>
-        </tr>
-        <tr>
-            <div class="form-group">
-                <td><label for="subject_ST">Province/State:</label></td>
-                <td><input type="text" id="subject_ST" name="subject_ST" class="form-control"></td>
-            </div>
-        </tr>
-        <tr>
-            <div class="form-group">
-                <td><label for="subject_O">Organization:</label></td>
-                <td><input type="text" id="subject_O" name="subject_O" class="form-control"></td>
-            </div>
-        </tr>
-        <tr>
-            <div class="form-group">
-                <td><label for="subject_OU">Organization Unit:</label></td>
-                <td><input type="text" id="subject_OU" name="subject_OU" class="form-control"></td>
-            </div>
-        </tr>
-        <tr>
-            <div class="form-group">
-                <td><label for="subject_emailAddress">Email:</label></td>
-                <td><input type="email" id="subject_emailAddress" name="subject_emailAddress" class="form-control"></td>
-            </div>
-        </tr>
-        <tr>
-            <td>Usage:</td>
-            <td class="form-check">
-                <input class="form-check-input" type="checkbox" id="isCA" name="isCA" value="CA">
-                <label class="form-check-label" for="isCA">CA</label><br>
-
-                <input class="form-check-input" type="checkbox" id="isDigitalSignature" name="isDigitalSignature" value="DigitalSignature">
-                <label class="form-check-label" for="isDigitalSignature">Digital Signature</label><br>
+                    <input class="form-check-input" type="checkbox" id="isDigitalSignature" name="isDigitalSignature" value="DigitalSignature">
+                    <label class="form-check-label" for="isDigitalSignature">Digital Signature</label><br>
 
-                <input class="form-check-input" type="checkbox" id="isAuthentication" name="isAuthentication" value="Authentication">
-                <label class="form-check-label" for="isAuthentication">Authentication</label><br>
+                    <input class="form-check-input" type="checkbox" id="isAuthentication" name="isAuthentication" value="Authentication">
+                    <label class="form-check-label" for="isAuthentication">Authentication</label><br>
 
-                <input class="form-check-input" type="checkbox" id="isSSL_TLS" name="isSSL_TLS" value="SSL_TLS">
-                <label class="form-check-label" for="isSSL_TLS">SSL/TLS</label><br>
-            </td>
-        </tr>
-        <tr>
-            <td colspan="2" align="center">
-                <button class="btn btn-success" onclick="window.location.href = '/static/index.html';">Create certificate</button>
-            </td>
-        </tr>
-    </table>
+                    <input class="form-check-input" type="checkbox" id="isSSL_TLS" name="isSSL_TLS" value="SSL_TLS">
+                    <label class="form-check-label" for="isSSL_TLS">SSL/TLS</label><br>
+                </td>
+            </tr>
+            <tr>
+                <td colspan="2" align="center">
+                    <button class="btn btn-success mt-3" onclick="window.location.href = '/static/index.html';">Create certificate</button>
+                </td>
+            </tr>
+        </table>
+    </div>
 </body>
 </html>
\ No newline at end of file